/*
 * @Author: Kane
 * @Date: 2023-10-13 14:39:06
 * @LastEditors: Kane
 * @FilePath: /desktop_archievement_backend/src/main/java/com/cpic/xim/web/controllers/dataimport/bi/ImportBIDataRequest.java
 * @Description: 
 * 
 * Copyright (c) ${2023} by Kane, All Rights Reserved. 
 */
package com.cpic.xim.web.controllers.dataimport.bi;

import org.springframework.stereotype.Controller;
import com.fasterxml.jackson.annotation.JsonProperty;

@Controller
public class ImportBIDataRequest
{
    public enum ReportType {
        TelsalerAttachingRateReport, TelsalerRenewalRateReport, DepartmentAttachingRenewalRateReport
    };

    // 导入文件的路径
    @JsonProperty( "filePath" )
    private String     filePath;

    // 报表名称
    @JsonProperty( "reportType" )
    private ReportType reportType;

    // 是否有标题行
    @JsonProperty( "hasCaption" )
    private boolean    hasCaption;

    // sheet索引
    @JsonProperty( "sheetIndex" )
    private int        sheetIndex;

    public ImportBIDataRequest()
    {}

    public boolean isHasCaption()
    {
        return hasCaption;
    }

    public void setHasCaption( boolean hasCaption )
    {
        this.hasCaption = hasCaption;
    }

    public int getSheetIndex()
    {
        return sheetIndex;
    }

    public void setSheetIndex( int sheetIndex )
    {
        this.sheetIndex = sheetIndex;
    }

    public String getFilePath()
    {
        return filePath;
    }

    public void setFilePath( String filePath )
    {
        this.filePath = filePath;
    }

    public ReportType getReportType()
    {
        return reportType;
    }

    public void setReportType( ReportType reportType )
    {
        this.reportType = reportType;
    }

    @Override
    public int hashCode()
    {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((filePath == null) ? 0 : filePath.hashCode());
        result = prime * result + ((reportType == null) ? 0 : reportType.hashCode());
        result = prime * result + (hasCaption ? 1231 : 1237);
        result = prime * result + sheetIndex;
        return result;
    }

    @Override
    public boolean equals( Object obj )
    {
        if ( this == obj )
            return true;
        if ( obj == null )
            return false;
        if ( getClass() != obj.getClass() )
            return false;
        ImportBIDataRequest other = (ImportBIDataRequest) obj;
        if ( filePath == null )
        {
            if ( other.filePath != null )
                return false;
        }
        else if ( !filePath.equals( other.filePath ) )
            return false;
        if ( reportType != other.reportType )
            return false;
        if ( hasCaption != other.hasCaption )
            return false;
        if ( sheetIndex != other.sheetIndex )
            return false;
        return true;
    }

    @Override
    public String toString()
    {
        return "ImportBIDataRequest [filePath=" + filePath + ", reportType=" + reportType
                + ", hasCaption=" + hasCaption + ", sheetIndex=" + sheetIndex + "]";
    }


}
